import static java.util.Arrays.asList;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;

class Book {}
class BookExt extends Book {}


public class Generics {
	public static void main(String[] args) {
		List<Integer> myList1 = new ArrayList<>();
		myList1.add(1);
		myList1.add(Integer.valueOf(1));
		Integer integer = myList1.get(0);

		List myList2 = new ArrayList();
		myList2.add(new Object());
		myList2.add(1);
		Object object = myList2.get(0);
//		Integer integer2 = (Integer)myList2.get(0);

		Map<String, Book> nameToBook = new HashMap<>();
		var nameToBook2 = new HashMap<String, Book>();

		var map = Map.of("a", new Book());
		
		var map2 = new HashMap<String, Book>() {{
			put("a", new Book());
		}};
		
		var map3 = new HashMap<String, Book>() {
			{
				put("a", new Book());
			}
		};

		System.out.println(map3.getClass().getName());
		System.out.println(map3);

		Object ertek = new Integer(4);
		Object ertek2 = Integer.valueOf(4);
		Object ertek3 = 4;
		
		
//		List<Object> lobj = new ArrayList<Integer>();
//		lobj.add(new Object());

		int[] elems = { 1, 2 };
		
//		Integer[] ints = new Integer[5];
//		Object[] objs = ints;
//		objs[0] = 4;
//		objs[1] = new Object();

		Map<List<Integer>, Integer> sumMap = new HashMap<>();
		List<Integer> nums1 = new ArrayList<>();
		nums1.add(1);
		nums1.add(2);
		nums1.add(3);
		List<Integer> nums2 = new ArrayList<>();
		nums2.add(1);
		nums2.add(2);
		nums2.add(3);

		sumMap.put(nums1, 5);
		System.out.println(sumMap.containsKey(nums1));
		System.out.println(sumMap.containsKey(nums2));
		
		Map<int[], Integer> sumMap2 = new HashMap<>();
		int[] numsArray1 = { 1, 2, 3 };
		int[] numsArray2 = { 1, 2, 3 };
		
		sumMap2.put(numsArray1, 5);
		System.out.println(sumMap2.containsKey(numsArray1));
		System.out.println(sumMap2.containsKey(numsArray2));
		System.out.println(numsArray1.equals(numsArray2));
		System.out.println(numsArray1.toString());

		List<Integer> list1  = new ArrayList<>(Arrays.asList(1, 2, 3));
		List<Integer> list1b = new ArrayList<>(asList(1, 2, 3));
		List<Integer> list2  = new ArrayList<>(List.of(1, 2, 3));

		// PECS: Producer Extends Consumer Super
		ArrayList<BookExt> books = new ArrayList<>();
		f(books);

		System.out.println(noSameObjs(list2));
		System.out.println(Generics.<Integer>noSameObjs(list2));
	}


	static void f(List<? extends Book> books) {
		books.stream().forEach(System.out::println);
	}

	static <T> boolean noSameObjs(List<T> elems) {
		return elems.size() == new HashSet<T>(elems).size();
	}
}




