import java.util.Comparator;
import java.util.TreeMap;

//Készítsünk “kulcs-érték-pár beszúrás”, “érték keresése kulcs alapján”, “kulcs keresése érték alapján” metódusokat.
//Készítsünk egy metódust, ami két listát kap, az egyik paramétere a kulcstípus, vagy annak egy altípusa, a másiké az értéktípus vagy annak egy altípusa. Ha a két lista egyező hosszú, akkor végigmegy rajtuk és berakja őket a BiMap-be.

public class GenericSolutions {
	public static void main(String[] args) {
		
	}
}

class BiMap<K, V> extends TreeMap<K, V> {
	private static final long serialVersionUID = 2019_03_20_001L;

	TreeMap<V, K> reverse;

	private BiMap() {
		super();
	}
	
	private BiMap(Comparator<K> cmp) {
		super(cmp);
	}
	
	public static <K2 extends Comparable<K2>,
				   V2 extends Comparable<V2>>
		BiMap<K2, V2> create() {
		BiMap<K2, V2> biMap = new BiMap<>();
		biMap.reverse = new TreeMap<>();
		return biMap;
	}
	
	public static <K2, V2>
		BiMap<K2, V2> create2(Comparator<K2> cmp1, Comparator<V2> cmp2) {
		BiMap<K2, V2> biMap = new BiMap<>(cmp1);
		biMap.reverse = new TreeMap<>(cmp2);
		return biMap;
	}

	@Override
	public V put(K key, V value) {
		super.put(key, value);
		reverse.put(value, key);
		return value;
	}
}
